--- /dev/null
+# $Id$
+
+PREFIX = C:/Tewi
+
+PLATFORM_IDENT = WINDOWS
+CC = ../vc4arm.sh
+AR = lib
+AR_FLAGS = /nologo /out:
+CFLAGS = -g -std=c99 -DPREFIX=\"$(PREFIX)\" -I ../Common -fPIC
+LDFLAGS =
+LIBS =
+EXEC = .exe
+STATIC = lib
+LIBSUF = .dll
+OBJ = obj
+PREOBJS = vc6.res
cm_log("Config", "Missing path at line %d", ln);
stop = 1;
} else {
+#ifndef WINCE
chdir(r[1]);
+#endif
free(config.server_root);
config.server_root = cm_strdup(r[1]);
}
int startup(int argc, char** argv);
-#if defined(__MINGW32__) || defined(_MSC_VER) || (defined(__WATCOMC__) && !defined(__OS2__) && !defined(__NETWARE__) && !defined(__DOS__)) || defined(__BORLANDC__)
+#if defined(__MINGW32__) || (defined(_MSC_VER) && !defined(WINCE)) || (defined(__WATCOMC__) && !defined(__OS2__) && !defined(__NETWARE__) && !defined(__DOS__)) || defined(__BORLANDC__)
char* get_registry(const char* main, const char* sub) {
DWORD bufsize = 512;
HKEY handle;
int startup(int argc, char** argv) {
int i;
char* r;
-#if defined(__MINGW32__) || defined(_MSC_VER) || (defined(__WATCOMC__) && !defined(__OS2__) && !defined(__NETWARE__) && !defined(__DOS__)) || defined(__BORLANDC__)
+#if defined(__MINGW32__) || (defined(_MSC_VER) && !defined(WINCE)) || (defined(__WATCOMC__) && !defined(__OS2__) && !defined(__NETWARE__) && !defined(__DOS__)) || defined(__BORLANDC__)
char* confpath = cm_strdup(PREFIX "/etc/tewi.conf");
char* regpath = get_registry("Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Tewi HTTPd", "InstallDir");
if(regpath != NULL) {
#if !defined(__MINGW32__) && !defined(_MSC_VER) && !defined(__BORLANDC__) && !defined(__WATCOMC__)
signal(SIGCHLD, SIG_IGN);
signal(SIGPIPE, SIG_IGN);
-#elif !defined(BUILD_GUI) && !defined(__OS2__) && !defined(__NETWARE__) && !defined(__DOS__)
+#elif !defined(BUILD_GUI) && !defined(__OS2__) && !defined(__NETWARE__) && !defined(__DOS__) && !defined(WINCE)
SetConsoleTitle(tw_server);
#endif
return -1;
#elif defined(__NETWARE__)
unsigned int* hnd = malloc(sizeof(*hnd));
#endif
+#ifndef WINCE
chdir(config.server_root);
+#endif
#if defined(__MINGW32__) || defined(_MSC_VER) || defined(__BORLANDC__) || defined(__WATCOMC__)
#ifdef __OS2__
if(DosLoadModule(tmp, 512, path, &mod) != NO_ERROR) {
}
lib = (void*)hnd;
#else
- lib = LoadLibraryA(path);
+ lib = LoadLibrary(path);
#endif
#else
lib = dlopen(path, RTLD_LAZY);
if(lib == NULL) {
cm_log("Module", "Could not load %s", path);
}
+#ifndef WINCE
chdir(p);
+#endif
free(p);
return lib;
}
return ret;
#elif defined(__NETWARE__)
return ImportSymbol(*(unsigned int*)mod, sym);
+#elif defined(WINCE)
+ return GetProcAddressW(mod, sym);
#else
return GetProcAddress(mod, sym);
#endif
-#include <winver.h>
+#include <windows.h>
#include "tw_version.h"
#include "../config.h"
--- /dev/null
+#!/bin/sh
+# $Id$
+# Wrapper for CL. VC6 sucks.
+
+outfile="a.out"
+dowhat=""
+options="/I../WCECompat /I../VC6Compat /D_NTSDK /Ddouble=long /DNEED_DIRECT /DARM /D_ARM_ /D_M_ARM /DARMV4I /D_ARMV4I_ /DWINCE /DUNICODE"
+obj=0
+win=0
+source=""
+libraries=""
+link=""
+
+for i in "$@"; do
+ if [ "$i" = "-o" ]; then
+ dowhat="output"
+ elif [ "$i" = "-I" ]; then
+ dowhat="include"
+ elif [ "$i" = "-c" ]; then
+ options="$options /c"
+ obj=1
+ elif [ "$i" = "-fPIC" ]; then
+ :
+ elif [ "$i" = "-g" ]; then
+ :
+ elif [ "$i" = "-std=c99" ]; then
+ :
+ elif [ "$i" = "-shared" ]; then
+ options="$options /LD"
+ elif [ "$i" = "-mwindows" ]; then
+ win=1
+ elif [ "`echo "$i" | grep -Eo "^-D"`" = "-D" ]; then
+ options="$options /`echo "$i" | sed "s/^-//g"`"
+ elif [ "`echo "$i" | grep -Eo "^-l"`" = "-l" ]; then
+ if [ "$i" = "-luser32" ]; then
+ libraries="$libraries gdi32.lib"
+ fi
+ if [ "$i" = "-lws2_32" ]; then
+ libraries="$libraries ws2.lib"
+ else
+ libraries="$libraries `echo "$i" | sed "s/^-l//g"`.lib"
+ fi
+ elif [ "$dowhat" = "output" ]; then
+ dowhat=""
+ outfile="$i"
+ elif [ "$dowhat" = "include" ]; then
+ dowhat=""
+ options="$options /I$i"
+ elif [ ! "`echo "$i" | grep -Eo "^."`" = "-" ]; then
+ source="$source $i"
+ fi
+done
+if [ "$obj" = "1" ]; then
+ options="$options /Fo$outfile"
+else
+ options="$options /Fe$outfile"
+fi
+if [ ! "$libraries" = "" ]; then
+ link="/link /subsystem:windowsce $libraries /libpath:../WCECompat wcecompat.lib"
+else
+ link="/link /subsystem:windowsce"
+fi
+if [ "$obj" = "0" ]; then
+ if [ "$win" = "1" ]; then
+ link="$link /SUBSYSTEM:windowsce"
+ fi
+fi
+construct="clarm /nologo $options $source $link"
+echo "Run: $construct"
+$construct